%global upstream elixir-lang
%global debug_package %{nil}
%bcond_with rebar

Summary:  A modern approach to programming for the Erlang VM
Name:     elixir
Version:  1.14.3
Release:  2%{?dist}

License:  ASL 2.0
URL:      https://elixir-lang.org/
Source0:  https://github.com/%{upstream}/%{name}/archive/v%{version}/%{name}-%{version}.tar.gz

BuildRequires: sed make
BuildRequires: erlang-sasl erlang-stdlib erlang-tools erlang-xmerl git
BuildRequires: erlang-inets erlang-kernel erlang-parsetools erlang-public_key
BuildRequires: erlang-compiler erlang-crypto erlang-dialyzer erlang-erts erlang-eunit
%if %{with rebar}
BuildRequires: erlang-rebar3
%endif


%description
Elixir is a programming language built on top of the Erlang VM.
As Erlang, it is a functional language built to support distributed,
fault-tolerant, non-stop applications with hot code swapping.

%prep
%autosetup

find -name '*.bat' -exec rm \{\} \;

rm lib/elixir/test/elixir/io/ansi_test.exs

find . -name .gitignore -delete
find . -name .gitkeep -delete

sed -i '/^Q\s*:=/d' Makefile

%if %{without rebar}
rm -f ./lib/mix/test/mix/rebar_test.exs
rm -f ./lib/mix/test/fixtures/rebar3
touch ./lib/mix/test/fixtures/rebar
touch ./lib/mix/test/fixtures/rebar3
%endif

%build
export LANG=C.UTF-8
%if %{with rebar}
export REBAR3=/usr/bin/rebar3
%endif
export ERL_LIBS=/usr/share/erlang/lib/
make compile
make build_man

%check
%if %{with rebar}
export REBAR3=/usr/bin/rebar3
%endif

export LANG=C.UTF-8
export ERL_LIBS=/usr/share/erlang/lib/
make test

%install
mkdir -p %{buildroot}/%{_datadir}/%{name}/%{version}
cp -ra bin lib %{buildroot}/%{_datadir}/%{name}/%{version}

mkdir -p %{buildroot}/%{_bindir}
ln -s %{_datadir}/%{name}/%{version}/bin/{elixir,elixirc,iex,mix} %{buildroot}/%{_bindir}/

mkdir -p %{buildroot}/%{_mandir}/man1
cp -a man/elixir.1 man/elixirc.1 man/iex.1 man/mix.1 %{buildroot}/%{_mandir}/man1

%files
%license LICENSE
%{_bindir}/elixir
%{_bindir}/elixirc
%{_bindir}/iex
%{_bindir}/mix
%{_datadir}/%{name}
%{_mandir}/man1/elixir.1*
%{_mandir}/man1/elixirc.1*
%{_mandir}/man1/iex.1*
%{_mandir}/man1/mix.1*

%changelog
* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.14.3-2
- Rebuilt for OpenCloudOS Stream 23.05

* Thu Apr 06 2023 cunshunxia <cunshunxia@tencent.com> - 1.14.3-1
- initial build
